'legoctr_ps.pb
'ԊOɂ郌SE{bg̑(vXepbh) for PIC-BASIC
'by

'PIC <----> PS PAD
' VCC------5:Vcc 3.6V
'          3:Vcc 7.6V
' RA.0*<---1:DAT
' RA.1---->2:CMD
' RA.2---->6:SEL
' RA.3---->7:CLK
'          9:ACK
' GND------4:GND
'   *PULL UPKv


Dim pad_buf(10) As Byte	'(PADp)
'  +0 null
'  +1 0x41='A'm[}[h / 0x53=AiO[h
'  +2 null
'  +3 sw1( LEFT / DOWN / RIGHT /  UP  / START /   1 /   1 / SEL
'  +4 sw2(    / ~   /     /    / R1    /  L1 /  R2 / L2
'  +5 Enh /E
'  +6 Enh /
'  +7 nh /E
'  +8 nh /

Dim pad_byte As Byte	'(PADp)
Dim tx_chr As Byte		'(PADp)MoCg
Dim rx_chr As Byte		'(PADp)MoCg
Dim lastbyte As Byte	'(PADp)coCg
Dim bitmask As Byte		'(PADp)}XNl
Dim cmd(11) As Byte		'R}h
Dim tmp As Byte			'e|
Dim parity As Byte		'peB
Dim code As Word		'R}hpR[h
Dim nop As Byte			'EGCg
Dim i As Byte			'e|


	'|[gCrbg2(RC2/CCP1)Lowo͂ɐݒ
High rc.Bit2

	'^C}2 Period RegisterPWMZbg
Poke &h92,130
	'PR2(AhX&h92)
	'38kHz=26.315us
	'(26.315us/4)/50ns=131.575    131-1=130

	'f[eBTCN8rbg(10bit)
Poke &h15,(220 >> 2)
	' CCPR1L(AhX&h15)
	'f[eB=f[eBTCN*NbN*^C}2̃vXP[
	'250cycle*50ns*1=12.5us

Poke &h12,&b100
	'T2CON(AhX&h12)
	'Bit2  : 1=^C}2(TMR2)I
	'Bit1-0: 00=vXP[1
	'        01=vXP[4
	'        1x=vXP[16

	'CCP̃[hݒ
Poke &h17,&b1100	'PWMJn
	'CCP1CON(AhX&h17)
	'Bit5-4:f[eBTCN̉2bit
	'Bit3-0:&b0000=disable
	'       &b11xx=PWM[h

Input rc.Bit2		'LED

Initlcd		'LCD 
Clearlcd
Gosub pad_init	'PAD 

Putlcd "LEGO RCX REMO.PS"

While 1
	Gosub pad_get	'pbh̎擾

	Setpos 0,1
    If (pad_buf(3) & (1 << 4))=0 Then	'
		Putlcd "UP   :A+ C+"
		code=&h08 | &h20	'A[^] | C[^]
		Gosub sendcmd
	Endif
	If (pad_buf(3) & (1 << 6))=0 Then	'
		Putlcd "DOWN :A- C-"
		code=&h40 | &h100	'A[^t] | C[^t]
		Gosub sendcmd
	Endif
    If (pad_buf(3) & (1 << 5))=0 Then	'E
		Putlcd "RIGHT:A+ C-"
		code=&h08 | &h100	'A[^] | C[^t]
		Gosub sendcmd
	Endif
	If (pad_buf(3) & (1 << 7))=0 Then	'
		Putlcd "LEFT :A- C+"
		code=&h40 | &h20	'A[^t] | C[^]
		Gosub sendcmd
	Endif

	Sleep 50
Wend

'-----------------------------------------------------------
'	RCX R}hM
'	()codeFR}h&h0000`ffff
'-----------------------------------------------------------
sendcmd:
	cmd(0) = &h55
	cmd(1) = &hff
	cmd(2) = &hff - cmd(1)
	cmd(3) = &hd2
	cmd(4) = &hff - cmd(3)
	cmd(5) = code / &h100	'R}h
	cmd(6) = &hff - cmd(5)
	cmd(7) = code Mod &h100	'R}h
	cmd(8) = &hff - cmd(7)
	cmd(9) = cmd(3) + cmd(5) + cmd(7)
	cmd(10) = &hff - cmd(9)

	For i=0 To 10
		tmp=cmd(i)
		Gosub send1byte
	Next
	Return

'-----------------------------------------------------------
'	RCX 1oCgM
'2400bps,peBodd,f[^rbg8,Xgbvrbg1
'()tmpFMf[^&h00`ff
'-----------------------------------------------------------
send1byte:
	'1rbg:X^[grbg
	Output rc.Bit2	'LED_
	parity=0
	nop=0
	nop=0
	nop=0
	nop=0
	nop=0
	nop=0
	nop=0
	nop=0

	'2`9rbgځFf[^rbg(8bit)
	Gosub databit
	Gosub databit
	Gosub databit
	Gosub databit
	Gosub databit
	Gosub databit
	Gosub databit
	Gosub databit

	'10rbgځFpeBrbg
	If((parity & 1)=0)Then
		Input rc.Bit2	'̏ꍇALED(1)
	Else
		Output rc.Bit2	'̏ꍇALED_(0)
	Endif
	nop=0
	nop=0
	nop=0
	nop=0
	nop=0
	nop=0
	nop=0

	'11rbgځFXgbvrbg
	Input rc.Bit2	'LED
	nop=0
	nop=0
	nop=0
	nop=0
	nop=0
	nop=0
	nop=0
	nop=0

	'12rbgځFEGCg
	nop=0
	nop=0
	nop=0
	nop=0
	nop=0
	nop=0
	nop=0
	Return

databit:
	If((tmp & 1)=0)Then
		Output rc.Bit2	'LED_(0)
		parity=parity+0
	Else
		Input rc.Bit2	'LED(1)
		parity=parity+1
	Endif
	tmp=tmp>>1
	nop=0
	nop=0
	nop=0
	Return

'-----------------------------------------------------------
'     pbh
'-----------------------------------------------------------
pad_init:
	Input ra.Bit0
	Output ra.Bit1
	Output ra.Bit2
	Output ra.Bit3

	High ra.Bit2	'SEL=H
	High ra.Bit3	'CLK=H
	Return


'-----------------------------------------------------------
'      pbh̎擾
'                                                           
'      +0 +1 +2 +3 +4 +5 +6 +7 +8                           
' CMD  01 42 00 00 00                                       
' DAT  ff 41 5a ** **               iʏj                
' DAT  ff 53 5a ** ** ** ** ** **   iAiOj            
' DAT  ff 73 5a ** ** ** ** ** **                           
'-----------------------------------------------------------
pad_get:
	pad_byte=0
	Low ra.Bit2		'SEL=L

                    '1oCgM(M[+0]=01h)
	tx_chr=&h01
	Gosub exc1byte	'Mf[^[+0]0xff


	tx_chr=&h42
	Gosub exc1byte	'1oCgM(M[+1]="B"42h)

	If (rx_chr=0) Or (rx_chr=&hff) Then pad_end

	lastbyte = (rx_chr & &h0f)* 2
		'Mf[^[+1]ID"A"
		'@(4bit)Rg[^Cv
		'@(4bit*2+1)McoCg

				'1oCgM(M[+2]=00h)
	tx_chr=0
	Gosub exc1byte	'Mf[^[+2]Z

    While(lastbyte > 0)
		'1oCgM(M[+3`]=00h)*/
		Gosub exc1byte	'Mf[^1oCgi[*/

		lastbyte = lastbyte - 1	'McoCg-1
    Wend

pad_end:
	High ra.Bit2    ' SEL=H
	Return    'I


'-----------------------------------------------------------
'     pbh 1oCgM                                  
'-----------------------------------------------------------
exc1byte:
	rx_chr = 0
	bitmask = 1

	'ʃrbg1oCgM

	While(bitmask>0)
		'CMD(R}h)
		If((tx_chr & bitmask) = 0) Then
			Low ra.Bit1
		Else
			 High ra.Bit1
		Endif
		Low ra.Bit3		' CLK=L
		If(ra.Bit0 = 1) Then rx_chr = rx_chr | bitmask	'DAT(f[^)ǂݎ
		High ra.Bit3	' CLK=H
		bitmask=bitmask << 1
	Wend

	pad_buf(pad_byte) = rx_chr
	pad_byte = pad_byte+1

	Return

